'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var globalConfigDefault = {
  src: 'src/**/*.*',
  dest: 'public'
};

var configList = _lodash2['default'].clone(globalConfigDefault);

var config = function gulpConfig(conf) {
  configList = _lodash2['default'].merge(configList, conf);
  return config;
};

config.getConf = function getConf(taskName) {
  for (var _len = arguments.length, deps = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    deps[_key - 1] = arguments[_key];
  }

  // prepare deps when some task name is 'css.clean'
  if (taskName && taskName.indexOf('.')) {
    deps = taskName.split('.').slice(1).concat(deps);
    taskName = taskName.split('.').shift();
  }

  var prev = configList[taskName];
  return taskName ? deps && deps.length ? deps.reduce(function (result, key) {
    if (result && result[key]) {
      prev = result;
      return result[key];
    } else if (prev) {
      return prev[key];
    }
    return null;
  }, configList[taskName]) : configList[taskName] || configList : configList;
};

config['default'] = function () {
  configList = _lodash2['default'].clone(globalConfigDefault);
  return config;
};

exports['default'] = config;
module.exports = exports['default'];